//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MixProbWins.h"
#include "Mixmaster.h"
#include "CpkKeyWins.h"
#include "MainMDI.h"
#include "HelpDlgs.h"
#include "Global.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma link "MixKeyWins"
#pragma resource "*.dfm"
TMixProbWin *MixProbWin=NULL;
const AnsiString MixShortCap = "Mix Duplicates";
//---------------------------------------------------------------------------
// TMixProbWin
//---------------------------------------------------------------------------
_fastcall TMixProbWin::TMixProbWin(TComponent* Owner)
  : TMixKeyWin(Owner)
{
   // unused
}
//---------------------------------------------------------------------------
__fastcall TMixProbWin::TMixProbWin(TComponent* Owner, AnsiString KeyFile,
   AnsiString TypFile, AnsiString ListFile) : TMixKeyWin(Owner)
{
   // unused
}
//---------------------------------------------------------------------------
__fastcall TMixProbWin::TMixProbWin(TComponent* Owner, bool Minimized)
   :TMixKeyWin(Owner)
{
   cap = Caption;
//==========================================
   keyring = mprobtxt; typfile = mtyp2txt;
//==========================================
   // kludge to get count of keys before actually initing keylist in Timer1Timer;
   TMixKeyList *tmp = new TMixKeyList(keyring);
   int H = 64+((tmp->Count+1)*19);
   if (H < 175) H = 175;
   if (H < Height) Height = H;
   delete tmp;
   // init other stuff
   WindowState = Minimized ? wsMinimized : wsNormal;
   SetNothingSelected();
   SetHelpBtnPos();
   // keylist needs init before timer1 call
   keynode = new TList();
   keylist = new TMixKeyList();
   dislist = new TMixKeyList();
   typlist = new TStringList(); typlist->Sorted = true;
   if (FileExists(typfile)) typlist->LoadFromFile(typfile);
   Load();
   keylist->GenTreeView(TreeView,typlist,keynode);
   SetNothingSelected();
   FormResize(NULL);
   SaveBtn->Enabled = false;
   checksave = true;
   typlistmod = false;
   modified = false;
   Caption = cap;
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
}
//---------------------------------------------------------------------------
__fastcall TMixProbWin::~TMixProbWin()
{
   MixProbWin = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::SaveProblems()
{
   if (keylist && typlist)
   {
      if (!keylist->Count)
      {
         if (FileExists(mprobtxt))
             DeleteFile(s(mprobtxt).c_str());
         Sleep(100);
         Close();
         return;
      }

      AnsiString type2="type2=";
      for (int i=0; i<typlist->Count; i++) type2 += "|"+typlist->Strings[i];
      TStringList *keys = new TStringList();
      keylist->SaveToStrings(keys);
      if (!keys->Count)
      {
         if (FileExists(s(mprobtxt)))
             DeleteFile(s(mprobtxt).c_str());
         delete keys;
         Sleep(300);
         Close();
         return;
      }
      keys->Insert(0,type2);
      keys->SaveToFile(mprobtxt);
      delete keys;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::Load()
{
   AnsiString type2,tline,kline;
   TStringList *keys = new TStringList();
   if (FileExists(keyring)) keys->LoadFromFile(keyring);
   while (keys->Count && keys->Strings[0].Trim().IsEmpty()) keys->Delete(0);
   keylist->Clear(); typlist->Clear();
   if (keys->Count && keys->Strings[0].Pos("type2=|"))
   {
      type2 = keys->Strings[0]; keys->Delete(0);
      int i=1; while((tline=GetToken(i++,type2,"|"))!="")
         typlist->Add(tline);
   }
   keylist->LoadFromStrings(keys);

   for (int i=0; i<keylist->Count; i++)
   {
      kline = keylist->CrtDesc(i);
      if (!InType2(kline,typlist)) typlist->Add(kline);
   }
   delete keys;
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::DumpNewKeys()
{
   TMixKeyList *keylist=MixProbWin->keylist;
   TStrings *newkeys=keylist->newkeys;
   for (int i=0; i<newkeys->Count; i++)
   {
      int pos=keylist->IndexOf(newkeys->Strings[i]);
      if (pos>=0) keylist->DeleteKey(pos);
   }
   GenTreeView();
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::FormResize(TObject *Sender)
{
   TMixKeyWin::FormResize(Sender);
   if (WindowState==wsMinimized) Caption = MixShortCap;
   else Caption = cap;
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::TransferKeysItemClick(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,"Transfer ALL keys to your mixmaster keyring?",
      "Confirm",MB_OKCANCEL)==IDOK)
   {
      cap = Caption; Caption = "Transfering keys...";
      AppProcessMessages(); Sleep(100);
      if (MixKeyWin) MixKeyWin->TreeView->Items->BeginUpdate();

      for (int k=0; k<keylist->Count; k++)
      {
         bool enabled=true;
         int bakcopies = STATSBAKCOPIES;
         AnsiString status,keydesc=keylist->Strings[k];

         for (int i=0; i<typlist->Count; i++)
            if ("#"+keydesc==typlist->Strings[i])
            {
               enabled = false;
               break;
            }
         if (MixKeyWin)
             MixKeyWin->AddRemailer((TStrings*)keylist->Objects[k],enabled);
         else
         {
            if (!enabled && FileExists(mtyp2txt))
            {
               TStringList *type2 = new TStringList();
               type2->Duplicates = dupIgnore;
               type2->LoadFromFile(mtyp2txt);
               type2->Add("#"+keylist->Strings[k]);
               SaveToFileBak(type2,mtyp2txt,bakcopies);
               delete type2;
            }
            TMixKeyList *keys = new TMixKeyList(mringtxt);
            keys->ImportAscii(keylist->ExportAscii(k));
            keys->SaveToFileBak(mringtxt,bakcopies);
            delete keys;
         }
      }
      TreeView->Items->BeginUpdate();
      TreeView->Items->Clear();
      TreeView->Items->EndUpdate();
      keylist->Clear();

      if (MixKeyWin) MixKeyWin->TreeView->Items->EndUpdate();
      Caption = cap;
      AppProcessMessages(); Sleep(100);
      Close();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::TransferKeyItemClick(TObject *Sender)
{
   if (curkey<0 || curkey>=keylist->Count) return;
   if (MsgBoxHwnd(Handle,"Transfer the current key to your mixmaster keyring?",
      "Confirm",MB_OKCANCEL)==IDOK)
   {
      if (MixKeyWin) MixKeyWin->TreeView->Items->BeginUpdate();

      cap = Caption; Caption = "Transfering key...";
      AppProcessMessages(); Sleep(100);

      bool enabled=true;
      int bakcopies = STATSBAKCOPIES;
      AnsiString keydesc=keylist->Strings[curkey];
      for (int i=0; i<typlist->Count; i++)
         if ("#"+keydesc==typlist->Strings[i])
         {
            enabled = false;
            break;
         }
      if (MixKeyWin)
          MixKeyWin->AddRemailer((TStrings*)keylist->Objects[curkey],enabled);
      else
      {
         if (!enabled && FileExists(mtyp2txt))
         {
            TStringList *type2 = new TStringList();
            type2->Duplicates = dupIgnore;
            type2->LoadFromFile(mtyp2txt);
            type2->Add("#"+keylist->Strings[curkey]);
            SaveToFileBak(type2,mtyp2txt,bakcopies);
            delete type2;
         }
         TMixKeyList *keys = new TMixKeyList(mringtxt);
         keys->ImportAscii(keylist->ExportAscii(curkey));
         keys->SaveToFileBak(mringtxt,bakcopies);
         delete keys;
      }
      Sleep(100);
      AppMainForm->Perform(WM_SHOWSTATUS,0,
         (LPARAM)s("The key for "+GetToken(0,keydesc," ")+" transfered!").c_str());
      TreeView->Items->BeginUpdate();
      TreeView->Items->Clear();
      TreeView->Items->EndUpdate();
      DeleteRemailer(curkey);
      Sleep(100);
      AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"All keys transfered!");

      if (MixKeyWin) MixKeyWin->TreeView->Items->EndUpdate();
   }
   Caption = cap;
   if (!TreeView->Items->Count)
   {
      Sleep(200);
      Close();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::DeleteBtnClick(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,"Delete this mixmaster remailer key?","Confirm",
       MB_OKCANCEL)==IDOK)
   {
      DeleteRemailer(curkey);
      if (!TreeView->Items->Count)
      {
         Sleep(200);
         Close();
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::TreeViewDragOver(TObject *Sender, TObject *Source,
  int X, int Y, TDragState State, bool &Accept)
{
   Accept = false;
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (keylist)
   {
      if (!keylist->Count) DeleteFile(s(mprobtxt).c_str());
      else SaveProblems();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::FormClose(TObject *Sender, TCloseAction &Action)
{
   if (!keylist || !keylist->Count) Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::HelpBtnClick(TObject *Sender)
{
   OpenHelp("MixmasterKeysDup","Duplicate Key Manager","");
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::WMAreYouKeyWindow(TMessage& Msg)
{
   Msg.Result = 1;
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::WMAreYouMixProbWindow(TMessage& Msg)
{
   Msg.Result = 1;
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::WMGetKeyringMenuDat(TMessage& Msg)
{
  KeyringMenuDat *menudat = (KeyringMenuDat*)Msg.LParam;
  bool hassel = curkey>=0;
  menudat->Modified = modified || typlistmod;
  menudat->HasSel = hassel;
  menudat->RefreshEnabled = RefreshBtn->Enabled;
  menudat->CurEnabled = EnabledKey(curkey);
  menudat->Count = keynode->Count;
  Msg.Result = 1;
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::WMKeyringClearItemClicked(TMessage& Msg)
{
   ClearAllBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::ClearAllBtnClick(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,
      s("Clear Mixmaster Duplicate Keys\n")+
      s("If you clear the keyring, you will be unable to\n")+
      s("undelete the items.\n\n")+
      s("Clear it anyway?"),
      "Confirm",MB_OKCANCEL)==IDOK)
   {
      TreeView->Items->BeginUpdate();
      TreeView->Items->Clear();
      TreeView->Items->EndUpdate();
      SetNothingSelected();
      modified = true;
      keylist->Clear();
      OkBtn->Click();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixProbWin::PopupMenu3Popup(TObject *Sender)
{
   TransferKeysItem->Enabled = keylist->Count>1;
   TransferKeyItem->Enabled = TreeView->Selected!=NULL;
}
//---------------------------------------------------------------------------
