//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "QueueDlgs.h"
#include "HelpDlgs.h"
#include "Pop3mail.h"
#include "MainMDI.h"
#include "FileMan.h"
#include "HeadMan.h"
#include "Msgwins.h"
#include "PgpMail.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma link "OpenDlgs"
#pragma resource "*.dfm"
TMailQueueDlg *MailQueueDlg;
//---------------------------------------------------------------------------
bool __fastcall OpenQueuedMail(AnsiString QueueName)
{
   MailQueueDlg = new TMailQueueDlg(QueueName,AppMainForm);
   bool ok = MailQueueDlg->Execute();
   delete MailQueueDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TMailQueueDlg::TMailQueueDlg(TComponent* Owner)
  : TOpenDlg(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMailQueueDlg::TMailQueueDlg(AnsiString QueueName, TForm *Owner)
  : TOpenDlg(Owner)
{
   TStrings *items=LookinBox->Items;
   if (QueueName==ProblemQueue)
   {
      items->Add(ProblemQueue);
      if (MainForm->OpenQueueBtn->Enabled) items->Add(MailQueue);
      SendBtn->Visible = false;
   }
   if (QueueName==MailQueue)
   {
      items->Add(MailQueue);
      if (MainForm->OpenProbsBtn->Enabled) items->Add(ProblemQueue);
      SendBtn->Visible = true;
   }
   LookinBox->ItemIndex = items->IndexOf(QueueName);
   LoadQueue(QueueName);
}
//---------------------------------------------------------------------------
void __fastcall TMailQueueDlg::LoadQueue(AnsiString &QueueName)
{
   ItemsBox->Clear();
   GetAppData(ItemsBox->Items,QueueName);
   ItemsBox->ItemIndex = -1;
   DeleteBtn->Enabled = false;
   OpenBtn->Enabled = false;
   ActiveControl = Panel1;
}
//---------------------------------------------------------------------------
bool __fastcall TMailQueueDlg::Execute()
{
   ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------

void __fastcall TMailQueueDlg::LookinBoxChange(TObject *Sender)
{
   if (LookinBox->Text!="") LoadQueue(LookinBox->Text);
}
//---------------------------------------------------------------------------
void __fastcall TMailQueueDlg::ItemsBoxClick(TObject *Sender)
{
   //SendBtn->Enabled = ItemsBox->Items->Count && ItemsBox->SelCount==0;
   DeleteBtn->Enabled = ItemsBox->SelCount>0;
   OpenBtn->Enabled = ItemsBox->SelCount>0;
}
//---------------------------------------------------------------------------
void __fastcall TMailQueueDlg::PopupMenu1Popup(TObject *Sender)
{
   PopDeleteItem->Enabled = ItemsBox->SelCount>0;
   PopOpenItem->Enabled = ItemsBox->SelCount>0;
}
//---------------------------------------------------------------------------
void __fastcall TMailQueueDlg::PopDeleteItemClick(TObject *Sender)
{
   int i;
   AnsiString quename=LookinBox->Text;
   if (MsgBoxHwnd(Handle,"Delete selected message(s)!\n\nAre you sure?",
          "Delete Message",MB_OKCANCEL)==IDOK)
   {
      for (i=0; i<ItemsBox->Items->Count; i++)
      if (ItemsBox->Selected[i])
         PutAppData(quename+PS+ItemsBox->Items->Strings[i],NULL);

      if (quename==ProblemQueue) AppMainForm->Perform(WM_PROBLEMCHANGE,0,NULL);
      if (quename==MailQueue) AppMainForm->Perform(WM_QUEUECHANGE,0,NULL);
   }
   LoadQueue(quename);
   //SendBtn->Enabled = ItemsBox->Items->Count && ItemsBox->SelCount==0;
}
//---------------------------------------------------------------------------
void __fastcall TMailQueueDlg::PopOpenItemClick(TObject *Sender)
{
   Sleep(100); Hide();
   int sels=ItemsBox->SelCount;
   AnsiString quename=LookinBox->Text;
   TStringList *msg = new TStringList();
   for (int i=0; i<ItemsBox->Items->Count; i++)
   if (ItemsBox->Selected[i])
   {
      AnsiString blank,msgname=ItemsBox->Items->Strings[i];
      GetAppData(msg,quename+PS+msgname);
      PutAppData(quename+PS+msgname,NULL);
      // remove 'Word-Wrap: ' header, if present
      THeaderManager *hm = new THeaderManager(msg);
      hm->Delete(WordWrapHeader);
      // get clrtxt and delete header
      int clrtxt=QSPoolHeaderToClearText(msg);
      if (clrtxt>0) QSPoolGet(msg,clrtxt);
      MessageWin = new TMessageWin(msg,blank,blank,AppMainForm);
      MessageWin->Editor->Modified = true; // so can't dump without notice
      MessageWin->Type = tNewMessage;
      MessageWin->DataKey = "";
      delete hm;
   }
   AppMainForm->Perform(WM_PROBLEMCHANGE,0,NULL);
   AppMainForm->Perform(WM_QUEUECHANGE,0,NULL);
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"Message(s) removed from queue!");
   ModalResult = mrOk;
   if (sels) MyBeep(MB_OK);
   delete msg;
}
//---------------------------------------------------------------------------
#define IDXSTRING(p,l) IndexStr.SubString(p,l)
AnsiString __fastcall TMailQueueDlg::MessageDate(AnsiString &IndexStr)
{
   //if (IndexStr==HeaderText) return GetParam(0,IndexStr," ");
   if (IndexStr.IsEmpty()) return "";

   AnsiString h,ampm="am";
   int H = IDXSTRING(12,2).ToIntDef(0);
   if (H>12) { H -= 12; ampm = "pm"; }
   h = H; if (h.Length()<2) h = "0"+h;
   return IDXSTRING(3,8)+"  "+h+":"+IDXSTRING(15,2)+" "+ampm+"  "+IndexStr.SubString(21,2);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMailQueueDlg::MessageWho(AnsiString &IndexStr)
{
   //if (IndexStr==HeaderText) return GetParam(1,IndexStr," "); // header
   if (IndexStr.IsEmpty()) return "";

   AnsiString who,ic=InCode,oc=OutCode;
   if (IndexStr[23]==ic[1] || IndexStr[23]==oc[1])
      who=HeadMan->GetAddress(GetParam(1,IndexStr,FieldSep.c_str()));
   else
      who=GetParam(3,IndexStr," "); // original style index
   return who;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMailQueueDlg::MessageSubject(AnsiString &IndexStr)
{
   //if (IndexStr==HeaderText) return GetParam(2,IndexStr," "); // header
   if (IndexStr.IsEmpty()) return "";

   int len,pos,fld;
   AnsiString sub,ic=InCode,oc=OutCode;
   if (IndexStr[23]==ic[1] || IndexStr[23]==oc[1]) // new style
      sub=GetParam(2,IndexStr,FieldSep.c_str());
   else
   {
      // original style
      len=IndexStr.Length();
      pos=len+1;
      fld=-2;
      for (int i=0; i<len; i++)
      {
         if (IndexStr[i]==' ') fld++;
         if (fld==(hPopLib?3:2))
         {
            pos = i+1;
            break;
         }
      }
      sub=IndexStr.SubString(pos,256);
   }
   return sub;
}
//---------------------------------------------------------------------------
void __fastcall TMailQueueDlg::ItemsBoxDrawItem(TWinControl *Control, int Index,
  TRect &Rect, TOwnerDrawState State)
{
   TListBox *lb = dynamic_cast<TListBox*>(Control);
   if (!lb) return;

   TRect r(Rect);
   lb->Canvas->FillRect(Rect);
   AnsiString text=lb->Items->Strings[Index];
   r.Left+=2, r.Right=r.Left+95;
   lb->Canvas->TextRect(r,r.Left,r.Top+2,MessageDate(text));
   r.Left+=104; r.Right=r.Left+145;
   lb->Canvas->TextRect(r,r.Left,r.Top+2,MessageWho(text));
   r.Left+=156; r.Right=Rect.Right-4;
   lb->Canvas->TextRect(r,r.Left,r.Top+2,MessageSubject(text));
}
//---------------------------------------------------------------------------
void __fastcall TMailQueueDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("QueuedMail","Queued Mail","",NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMailQueueDlg::SendBtnClick(TObject *Sender)
{
   for (int i=0; i<ItemsBox->Items->Count; i++)
      ItemsBox->Selected[i] = false;

   Sleep(100); Hide();
   AppMainForm->Perform(WM_SENDMAIL,0,NULL);
   Close();
}
//---------------------------------------------------------------------------
