//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <time.h>
#pragma hdrstop

#include "pgp.h"
#include "pgpdb.h"
#include "pgpmail.h"
#include "pgpkeywins.h" // TPGPbuffer
#include "global.h"
#include "view.h"
#include "mixmaster.h"
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int __fastcall PgpKeyCount(TStrings *KeyDoc)
{
   int keys=0;
   for (int i=0; i<KeyDoc->Count; i++)
      if (KeyDoc->Strings[i].Trim()==PgpBeginPubKeyBlock ||
          KeyDoc->Strings[i].Trim()==PgpBeginSecKeyBlock)
      {
         keys++;
      }
   return keys;
}
//---------------------------------------------------------------------------
int __fastcall pgpdb_getnextblk(TStrings *keylist,TStringList *block)
{
   block->Clear();
   AnsiString keyline;
   while (keylist->Count && keylist->Strings[0].IsEmpty()) keylist->Delete(0);
   if (!keylist->Count) return -1;

   while (keylist->Count)
   {
      keyline = keylist->Strings[0];
      block->Add(keyline); keylist->Delete(0);
      if (keyline==PgpEndPubKeyBlock || keyline==PgpEndSecKeyBlock)
         return 0;
   }
   return -1;
}
//---------------------------------------------------------------------------
int __fastcall pgpdb_getnextkey(BUFFER *db, BUFFER *key)
{
  long ptr;
  int type;
  BUFFER *p=buf_new();

  buf_clear(key);
  bool quitnow=false,havekey=false;
  if ((type=pgp_getpacket(db,p))>-1)
  {
     pgp_packet(p,type); buf_cat(key, p);
     while ((ptr=db->ptr,type=pgp_getpacket(db, p))>0)
     {
        havekey = true;
        switch (type)
        {
           case PGP_SECKEY:
           case PGP_PUBKEY:
              db->ptr = ptr;
              quitnow = true;
              break;
           case PGP_PUBSUBKEY:
           case PGP_SECSUBKEY:
	            break;
           case PGP_USERID:
              break;
        }
        if (quitnow) break;

        pgp_packet(p, type);
        buf_cat(key, p);
     }
  }
  buf_free(p);
  return (havekey ? 0 : -1);
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetAddresses(AnsiString &fromLine)
{
   UINT B,E,L,at;
   AnsiString addr,from=fromLine,Terms="<>, =\r\n()";
   while ((at=from.Pos("@"))>0)
   {
      B=E=at; L=from.Length();
      while (B>1 && !Terms.Pos(from[B-1])) B--;
      while (E<L && !Terms.Pos(from[E+1])) E++;
      addr += (addr.IsEmpty()?"":"/")+from.SubString(B,E-(B-1));
      from = from.SubString(E+2,512);
   }
   return addr;
}
//---------------------------------------------------------------------------
__fastcall TPgpDB::TPgpDB()
   : TObject()
{
   status = 0;
   modified = false;
   keys = new TStringList();
   keys->Duplicates = dupAccept;
   keys->Sorted = true;
}
//---------------------------------------------------------------------------
__fastcall TPgpDB::TPgpDB(AnsiString Keyring)
   : TObject()
{
   status = 0;
   modified = false;
   allowduplicates = false;
   keys = new TStringList(); keys->Sorted = true; keys->Duplicates = dupAccept;

   if (FileExists(Keyring))
   {
      int k;
      AnsiString keyring = Keyring;
      TPGPbuffer *key = new TPGPbuffer();
      TPGPbuffer *ring = new TPGPbuffer(keyring);
      while (key->CopyKeyFrom(ring))
      {
         TPgpDBKey *dbkey = new TPgpDBKey(key);
         if ((k=Find(dbkey))<0 || GetKey(k)->Type()!=dbkey->Type()) AddKey(dbkey);
         delete dbkey;
         key->clear();
      }
      delete ring;
      delete key;

      /*int c=0;
      BUFFER *buf=buf_new(),*armored=buf_new(),*keybuf=buf_new();
      buf_readfile(armored,Keyring.c_str());
      if (pgp_ispacket(armored)) buf_move(keybuf,armored);
      else
      {
         TStringList *blk = new TStringList();
         TStringList *keylist = new TStringList();
         keylist->SetText((char*)armored->data); buf_clear(armored);
         while (pgpdb_getnextblk(keylist,blk)==0)
         {
            buf_sets(armored,blk->Text.c_str());
            pgp_dearmor(armored,buf);
            buf_cat(keybuf,buf);
            c++;
         }
         delete keylist;
         delete blk;
      }
      while (pgpdb_getnextkey(keybuf,buf)==0)
      {
         int k;
         TPgpDBKey *key = new TPgpDBKey(buf);
         if ((k=Find(key))<0 || GetKey(k)->Type()!=key->Type()) AddKey(key);
         delete key;
      }
      if (c==1)
      {
         //TStringList *keys = new TStringList();
         //SaveToStrings(keys);
         //view(keys);
         //delete keys;
      }
      buf_free(armored);
      buf_free(keybuf);
      buf_free(buf);*/
   }
}
//---------------------------------------------------------------------------
__fastcall TPgpDB::TPgpDB(TStrings *AsciiKeys)
   : TObject()
{
   status = 0;
   modified = false;
   allowduplicates = false;
   keys = new TStringList(); keys->Sorted = true; keys->Duplicates = dupAccept;

   int k;
   TPGPbuffer *key = new TPGPbuffer();
   TPGPbuffer *ring = new TPGPbuffer(AsciiKeys);
   while (key->CopyKeyFrom(ring))
   {
         TPgpDBKey *dbkey = new TPgpDBKey(key);
         if ((k=Find(dbkey))<0 || GetKey(k)->Type()!=dbkey->Type()) AddKey(dbkey);
         delete dbkey;
         key->clear();
   }
   delete ring;
   delete key;

   /*BUFFER *armored=buf_new(),*keybuf=buf_new(),*buf=buf_new();
   TStringList *blk = new TStringList();
   while (pgpdb_getnextblk(AsciiKeys,blk)==0)
   {
      buf_sets(armored,blk->Text.c_str());
      pgp_dearmor(armored,buf);
      buf_cat(keybuf,buf);
   }
   delete blk;
   while (pgpdb_getnextkey(keybuf,buf)==0)
   {
      TPgpDBKey *key = new TPgpDBKey(buf);
      if (Find(key)<0) AddKey(key);
      else delete key;
   }
   buf_free(armored);
   buf_free(keybuf);
   buf_free(buf);*/
}
//---------------------------------------------------------------------------
__fastcall TPgpDB::~TPgpDB()
{
   Clear(); // *deletes* all keys
   delete keys;
}
//---------------------------------------------------------------------------
TPgpDBKey* __fastcall TPgpDB::GetKey(int Pos)
{
   if (Pos<0 || Pos>=keys->Count) return NULL;
   return dynamic_cast<TPgpDBKey*>(keys->Objects[Pos]);
}
//---------------------------------------------------------------------------
int __fastcall TPgpDB::KeyCount()
{
   return keys->Count;
}
//---------------------------------------------------------------------------
void __fastcall TPgpDB::SaveToFile(AnsiString &FileName, bool Armored)
{
   BUFFER *buf=buf_new();
   SaveToBuffer(buf);
   if (Armored) pgp_armor(buf,2);
   buf_writefile(buf,FileName.c_str(),"wb");
   buf_free(buf);
}
//---------------------------------------------------------------------------
void __fastcall TPgpDB::SaveToFileBak(AnsiString &FileName, int bakcopies, bool Armored)
{
   for (int i=bakcopies; i>=1; i--)
   {
      if (FileExists(bak(FileName,i))) DeleteFile(bak(FileName,i).c_str());
      if (FileExists(bak(FileName,i-1)))
          rename(bak(FileName,i-1).c_str(),bak(FileName,i).c_str());
   }
   if (FileExists(FileName))
      rename(FileName.c_str(),bak(FileName,1).c_str());
   SaveToFile(FileName,Armored);
}
//---------------------------------------------------------------------------
TStrings* __fastcall TPgpDB::SaveToStrings(TStrings *AsciiStrings)
{
   AsciiStrings->Clear();
   for (int k=0; k<keys->Count; k++)
   {
      TPgpDBKey *key = GetKey(k);
      AsciiStrings->Add(key->Description());
      AsciiStrings->Add("");
      AsciiStrings->Add(key->AsciiArmored());
      AsciiStrings->Add("");
   }
   return AsciiStrings;
}
/*
//---------------------------------------------------------------------------
bool __fastcall TPgpDB::GetShortAndAddress(AnsiString &UserIds, AnsiString &ShortName,
   AnsiString &Address, TStrings *cpklist)
{
   bool ok=false;
   AnsiString id,addrs,line;
   TStringList *ids = new TStringList();
   int p=0; while ((id=GetParam(p++,UserIds,"/"))!="") ids->Add(id);
   for (int c=0; c<cpklist->Count; c++) // check rlist.txt lines 1 by 1
   {
      line = cpklist->Strings[c];
      if (line.Pos("$remailer{")!=1) continue; // skip lines that are not NOT $remailer

      for (int i=0; i<ids->Count; i++) // test each userid
      {
         addrs = ids->Strings[i];
         if (line.Pos(addrs)>0)
         {
            Address = addrs;
            ShortName = GetParam(1,line,"\"");
            ok = true;
            break;
         }
      }
      if (ok) break;
   }
   delete ids;
   return ok;
}
*/
//---------------------------------------------------------------------------
TStrings* __fastcall TPgpDB::SaveToStringsPlus(TStrings *Strings)
{
   Strings->Clear();
   for (int k=0; k<keys->Count; k++)
   {
      bool modified=false;
      TPgpDBKey *key = GetKey(k);
      // make assignments to strings
      Strings->Add(
         "CTB="+s(key->CTB())+CFS+
         "Type="+s(key->Type())+CFS+
         "KeyId=0x"+key->IdText8()+CFS+
         "UserIds="+key->KeyUserIdsRow()+CFS+
         "Addresses="+key->Addresses()+CFS+
         "TimeStamp="+s((int)key->TimeStamp())+CFS+
         "Validity="+s(key->Validity())+CFS+
         "Algorithm="+s(key->Algorithm())+CFS+
         "Version="+s(key->Version())+CFS+
         "KeyBits="+s(key->KeyBits())+CFS+
         "Modified="+(modified?s("1"):s("0"))+CFS+
         "Disabled=0");
      Strings->Add("");
      Strings->Add(key->AsciiArmored());
   }
   return Strings;
}
//---------------------------------------------------------------------------
TStrings* __fastcall TPgpDB::SaveToStringsCpk(TStrings *Strings, TStrings *Clist)
{
   Strings->Clear();
   for (int k=0; k<keys->Count; k++)
   {
      bool modified=false;
      TPgpDBKey *key = GetKey(k);
      // workout the shortname and address
      AnsiString shrt=key->CpkShort(),addr=key->CpkAddress();
      if (shrt.IsEmpty())
      {
         AnsiString uids = key->Addresses();
         if (!GetShortAndAddress(uids,shrt,addr,Clist))
         {
            addr = GetAddresses(GetParam(0,key->KeyUserIdsRow(),"|"));
            shrt = NoNameYet;
         }
      }
      // make assignments to strings
      Strings->Add(
         shrt+" "+addr+" 0x"+key->IdText8()+" "+  // 0,1,2
         s(key->CTB())+" "+                       // 3
         s(key->Type())+" "+                      // 4
         //key->Addresses()+" "+                    // 5
         s((int)key->TimeStamp())+" "+            // 5
         s(key->Validity())+" "+                  // 6
         s(key->Algorithm())+" "+                 // 7
         s(key->Version())+" "+                   // 8
         s(key->KeyBits())+" "+                   // 9
         s(modified?"1":"0")+" "+  // need save?  // 10
         s("0")+" "+               // disabled?   // 11
         //UFS+" "+   // field separator for uids   // 12
         key->KeyUserIdsRow()                     // 12
      );
      Strings->Add("");
      Strings->Add(key->AsciiArmored());
//view(Strings,"TEST");
      // make assignments to strings
      /*Strings->Add(
         "CTB="+s(key->CTB())+CFS+
         "Type="+s(key->Type())+CFS+
         "KeyId=0x"+key->IdText8()+CFS+
         "ShortName="+shrt+CFS+
         "Address="+addr+CFS+
         "UserIds="+key->KeyUserIdsRow()+CFS+
         "Addresses="+key->Addresses()+CFS+
         "TimeStamp="+s((int)key->TimeStamp())+CFS+
         "Validity="+s(key->Validity())+CFS+
         "Algorithm="+s(key->Algorithm())+CFS+
         "Version="+s(key->Version())+CFS+
         "KeyBits="+s(key->KeyBits())+CFS+
         "Modified="+(modified?s("1"):s("0"))+CFS+
         "Disabled=0");
      Strings->Add("");
      Strings->Add(key->AsciiArmored());*/
   }
   return Strings;
}
//---------------------------------------------------------------------------
bool __fastcall TPgpDB::GetShortAndAddress(AnsiString &UserIds, AnsiString &ShortName,
   AnsiString &Address, TStrings *cpklist)
{
   bool ok=false;
   AnsiString id,addrs,line;
   TStringList *ids = new TStringList();
   int p=0; while ((id=GetParam(p++,UserIds,"/"))!="") ids->Add(id);
   for (int i=0; i<ids->Count; i++) // test each userid
   {
      addrs = ids->Strings[i];
      if ((ShortName=cpklist->Values[addrs]).IsEmpty()) continue;
      Address = addrs;
      ok = true;
      break;
   }
   delete ids;
   return ok;
}
//---------------------------------------------------------------------------
TStrings* __fastcall TPgpDB::SaveToStringsCpkDesc(TStrings *Strings, TStrings *Clist)
{
   Strings->Clear();
   for (int k=0; k<keys->Count; k++)
   {
      //bool modified=false;
      TPgpDBKey *key = GetKey(k);
      // workout the shortname and address
      AnsiString shrt=key->CpkShort(),addr=key->CpkAddress();
      AnsiString uids=key->Addresses();
      if (shrt.IsEmpty())
      {
         if (!GetShortAndAddress(uids,shrt,addr,Clist))
         {
            addr = GetAddresses(GetParam(0,key->KeyUserIdsRow(),"|"));
            shrt = NoNameYet;
         }
      }
      Strings->Add(shrt+" "+uids+" 0x"+key->IdText8());
      Strings->Add("");
      Strings->Add(key->AsciiArmored());
   }
   return Strings;
}
//---------------------------------------------------------------------------
BUFFER* __fastcall TPgpDB::SaveToBuffer(BUFFER *Buffer)
{
   buf_clear(Buffer);
   for (int k=0; k<keys->Count; k++)
      buf_cat(Buffer,GetKey(k)->key);
   return Buffer;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpDB::SaveToString()
{
   TStringList *keys = new TStringList();
   SaveToStrings(keys);
   AnsiString keystr = keys->Text;
   delete keys;
   return keystr;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDB::AddKey(TStrings *AsciiKey)
{
   if (AsciiKey==NULL || !AsciiKey->Count) return -1;
   TPgpDBKey *key = new TPgpDBKey(AsciiKey);
   return AddKey(key);
}
//---------------------------------------------------------------------------
int __fastcall TPgpDB::AddKey(TPgpDBKey *Key)
{
   if (Key==NULL) return -1;
   TPgpDBKey *key = new TPgpDBKey(Key);
   return keys->AddObject(key->Description(),key);
}
//---------------------------------------------------------------------------
int __fastcall TPgpDB::AddKey(BUFFER *KeyBuf)
{
   if (KeyBuf==NULL) return -1;
   TPgpDBKey *key = new TPgpDBKey(KeyBuf);
   return keys->AddObject(key->Description(),key);
}
//---------------------------------------------------------------------------
int __fastcall TPgpDB::Find(TPgpDBKey* Key)
{
   int pos=-1;
   if (!Key) return pos;
   for (int k=0; k<keys->Count; k++)
   {
      TPgpDBKey *key = GetKey(k);
      if (Key->IdText8()==key->IdText8() && Key->Type()==key->Type())
      {
         pos = k;
         break;
      }
   }
   return pos;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDB::Find(BUFFER *KeyBuf)
{
   int pos=-1;
   if (!KeyBuf) return pos;
   TPgpDBKey *Key = new TPgpDBKey(KeyBuf);
   for (int k=0; k<keys->Count; k++)
   {
      TPgpDBKey *key = GetKey(k);
      if (Key->IdText8()==key->IdText8() && Key->Type()==key->Type())
      {
         pos = k;
         break;
      }
   }
   delete Key;
   return pos;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDB::FindDescrip(AnsiString &Descrip)
{
   int pos=-1;
   for (int k=0; k<keys->Count; k++)
   {
      TPgpDBKey *key = GetKey(k);
      if (key && key->Description()==Descrip)
      {
         pos = k;
         break;
      }
   }
   return pos;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDB::Delete(int position)
{
   int k=position;
   if (k<0 || k>=keys->Count) return -1;

   // delete TPgpDBKey first, then description from keys list
   delete GetKey(k); keys->Delete(k);
   modified = true;
   return k;
}
//---------------------------------------------------------------------------
void __fastcall TPgpDB::Clear()
{
   while (keys->Count)
      Delete(0);
}
//---------------------------------------------------------------------------
// TPgpDBKey
//---------------------------------------------------------------------------
__fastcall TPgpDBKey::TPgpDBKey(TPgpDBKey *Key)
   : TObject()
{
   key = buf_new();
   buf_set(key,Key->key);
   pair = NULL;
   status = 0;
}
//---------------------------------------------------------------------------
__fastcall TPgpDBKey::TPgpDBKey(TPGPbuffer *Key)
   : TObject()
{
   key = buf_new();
   buf_append(key,Key->data,Key->length);
   pair = NULL;
   status = 0;
}
//---------------------------------------------------------------------------
__fastcall TPgpDBKey::TPgpDBKey(BUFFER *Key)
   : TObject()
{
   key = buf_new();
   buf_set(key,Key);
   pair = NULL;
   status = 0;
}
//---------------------------------------------------------------------------
__fastcall TPgpDBKey::TPgpDBKey(TStrings *AsciiKey)
{
   key=buf_new();
   AnsiString Fline,Lline;
   int i=0; while (i<AsciiKey->Count &&
      AsciiKey->Strings[i]!=PgpBeginPubKeyBlock && AsciiKey->Strings[i]!=PgpBeginSecKeyBlock)
         i++;
   TStringList *Block = new TStringList();
   for (i=i; i<AsciiKey->Count; i++)
      Block->Add(AsciiKey->Strings[i]);
   if (!Block->Count)
   {
      status = -3;
      return;
   }
   Fline = Block->Strings[0];
   if (Fline!=PgpBeginPubKeyBlock && Fline!=PgpBeginSecKeyBlock)
   {
      status = -2;
      return;
   }
   Lline = Block->Strings[Block->Count-1];
   if ((Fline==PgpBeginPubKeyBlock && Lline!=PgpEndPubKeyBlock) ||
       (Fline==PgpBeginPubKeyBlock && Lline!=PgpEndPubKeyBlock))
   {
      status = -1;
      return;
   }
//sm(Block->Text);
   BUFFER *armored = buf_new();
   buf_sets(armored,Block->Text.c_str());
   pgp_dearmor(armored,key);
   buf_free(armored);
   pair = NULL;
   status = 0;
}
//---------------------------------------------------------------------------
__fastcall TPgpDBKey::~TPgpDBKey()
{
   buf_free(key);
}
//---------------------------------------------------------------------------
int __fastcall TPgpDBKey::Type()
{
   int type = -1;
   int CTB = key->data[0];
//   if ((CTB & 24)==24) type = PGP_PUBKEY; else
//   if ((CTB & 20)==20) type = PGP_SECKEY;
   if (CTB==153) type = PGP_PUBKEY; else
   if (CTB==149) type = PGP_SECKEY;
   return type;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDBKey::CTB()
{
   return key->data[0];
}
//---------------------------------------------------------------------------
int __fastcall TPgpDBKey::PutMPI(BUFFER *buf, BUFFER *mpi)
{
  int l,i;
  l = mpi->length * 8;
  for (i = 7; i >= 0; i--)
    if (((mpi->data[0] >> i) & 1) == 1) {
      l -= 7 - i;
      break;
    }
  buf_appendi(buf, l);
  buf_cat(buf, mpi);
  return (l);
}
//---------------------------------------------------------------------------
int __fastcall TPgpDBKey::GetMPI(BUFFER *mpi)
{
  int l=buf_geti(key);
  if (l <= 0 || key->ptr + (l + 7) / 8 > key->length) return (-1);
  buf_get(key, mpi, (l + 7) / 8);
  return (l);
}
//---------------------------------------------------------------------------
int __fastcall TPgpDBKey::KeyId(BUFFER *keyid)
{
  BUFFER *i,*k;
  int version,algo,j;
  long ptr;

  i = buf_new();
  k = buf_new();
  ptr = key->ptr; key->ptr = 3;
  switch (version=buf_getc(key))
  {
     case 2:
     case 3:
        buf_getl(key); // timestamp
        buf_geti(key); // validity
        buf_getc(key); // algo
        GetMPI(i);
        break;
     case 4:
        buf_appendc(k, (char)version);
        buf_appendl(k, buf_getl(key));
        algo = buf_getc(key);
        buf_appendc(k, (char)algo);
        if (pgp_nummpi(algo) == 0) buf_rest(k, key); /* works for public keys only */
        else
           for (j = 0; j < pgp_nummpi(algo); j++)
           {
	            GetMPI(i);
 	            PutMPI(k,i);
           }
        buf_clear(i);
        buf_appendc(i, 0x99);
        buf_appendi(i, k->length);
        buf_cat(i, k);
        digest_sha1(i, i);
        break;
  }
  buf_clear(keyid);
  buf_append(keyid, i->data + i->length - 8, 8);
  key->ptr = ptr;
  buf_free(i);
  buf_free(k);
  return(0);
}
//---------------------------------------------------------------------------
int  __fastcall TPgpDBKey::Validity()
{
   key->ptr = 8;
   return buf_geti(key);
}
//---------------------------------------------------------------------------
int  __fastcall TPgpDBKey::KeyBits()
{
   key->ptr = 11;
   BUFFER *tmp=buf_new();
   long bits = buf_geti(key);
   delete tmp;
   return bits;
}
//---------------------------------------------------------------------------
byte __fastcall TPgpDBKey::Algorithm()
{
   key->ptr = 10;
   return (byte)buf_getc(key); // RSA=1
}
//---------------------------------------------------------------------------
byte __fastcall TPgpDBKey::Version()
{
   key->ptr = 3;
   return (byte)buf_getc(key);
}
//---------------------------------------------------------------------------
long __fastcall TPgpDBKey::TimeStamp()
{
   key->ptr = 4;
   return buf_getl(key); // timestamp
}
//---------------------------------------------------------------------------
bool __fastcall TPgpDBKey::IsPair()
{
   return false;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpDBKey::CpkAddress()
{
   int type;
   buf_rewind(key);
   AnsiString tmp,addr;
   BUFFER *pk=buf_new();
   while ((type=pgp_getpacket(key,pk))>0)
   {
      if (type==PGP_COMMENT) tmp = (char*)pk->data;
      if (tmp.Pos("Address=")==1)
      {
         addr = tmp.SubString(9,64);
         break;
      }
   }
   buf_free(pk);
   return addr;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpDBKey::CpkShort()
{
   int type;
   buf_rewind(key);
   AnsiString tmp,shrt;
   BUFFER *pk=buf_new();
   while ((type=pgp_getpacket(key,pk))>0)
   {
      if (type==PGP_COMMENT) tmp = (char*)pk->data;
      if (tmp.Pos("ShortName=")==1)
      {
         shrt = tmp.SubString(11,64);
         break;
      }
   }
   buf_free(pk);
   return shrt;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpDBKey::Description()
{
   TStringList *ids = new TStringList();
   ids->Text = KeyUserIds();
   AnsiString desc=GetAddresses(ids->Text);
   if (desc.IsEmpty() && ids->Count)
   {
      desc = ids->Strings[0];
      int pos; while ((pos=desc.Pos(" "))>0)
         desc.Delete(pos,1);
   }
   desc = desc+" 0x"+IdText8();
   delete ids;
   return desc;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpDBKey::IdText8()
{
 	 byte c;
   AnsiString text8;
   BUFFER *id = buf_new();
   KeyId(id);
	 for (int i=0; i<4; i++)
   {
 	  	 c = id->data[4+i];
		 text8 += "0123456789ABCDEF" [ c >> 4  ];
		 text8 += "0123456789ABCDEF" [ c & 0xf ];
	 }
   buf_free(id);
   return text8;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpDBKey::KeyUserIds(int pos)
{// this function returns id at pos unless pos = -1 returns
 // entire list, pos >= ids->count returns ""
   int type;
   buf_rewind(key);
   BUFFER *pk=buf_new();
   TStringList *userids = new TStringList();
   while ((type=pgp_getpacket(key,pk))>0)
   {
      if (type==PGP_USERID) userids->Add((char*)pk->data);
   }
   AnsiString ids;
   if (pos<0) ids = userids->Text; else
   if (pos<userids->Count) ids = userids->Strings[pos];
   delete userids;
   buf_free(pk);
   return ids;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpDBKey::Addresses()
{
   return GetAddresses(KeyUserIdsRow());
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpDBKey::KeyUserIdsRow()
{
   int type;
   buf_rewind(key);
   AnsiString userids;
   BUFFER *pk=buf_new();
   while ((type=pgp_getpacket(key,pk))>0)
   {
      if (type==PGP_USERID)
      {
         if (!userids.IsEmpty()) userids += "|";
         userids += s((char*)pk->data);
      }
   }
   buf_free(pk);
   return userids;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpDBKey::AsciiArmored()
{
   BUFFER *armored = buf_new();
   buf_set(armored,key);
   pgp_armor(armored,2);
   AnsiString string = (char*)armored->data;
   buf_free(armored);
   return string;
}
//---------------------------------------------------------------------------



